/********************************************************
 *
 *  Copyright (c) 2015 Sony Corporation
 *
 ********************************************************/

#ifndef __FMD_DMA_H__
#define __FMD_DMA_H__


extern void         fmd_dma_initialize(u32 pci_addr);
extern void         fmd_dma_finalize(void);
extern int          fmd_dma_reset(u32 bit);
extern void         fmd_dma_init_intr(void);
extern irqreturn_t  fmd_dma_intr_msi(int irq, void* data);
extern void         fmd_msgdma_finalize(void);
extern int          fmd_msgdma_reset_and_wait_ready(void);
extern size_t       fmd_dma_get_safty_size(size_t size);
extern int          fmd_dma_put_descriptor(u32 dma_paddr, u32 mask, u32 offset, size_t size, boolean is_read);
extern int          fmd_dma_wait(void);
extern int          fmd_dma_read(char* dma_vbuf, char __user* buf, size_t size);
extern ssize_t      fmd_dma_write(char* dma_vbuf, const char __user* buf, size_t size);
extern int          fmd_dma_get_status(void);
extern int          fmd_dma_show_status(void);


#endif // __FMD_DMA_H__
