/********************************************************
 *
 *  Copyright (c) 2015 Sony Corporation
 *
 ********************************************************/

#ifndef __FMDRIVER_H__
#define __FMDRIVER_H__

typedef struct {
    unsigned long long  offset;
    unsigned int        size;
    unsigned char*      data;
} ioctl_set_t;

/* Just a magic number for /dev/Altera */
/* See /usr/share/kernel/Documentation/ioctl-number.txt */
/* See /usr/src/kernels/2.6.18-274.17.1.el5-x86_64/include/asm-generic/ioctl.h */
#define IOC_MAGIC 0xAE

#define IOCTL_WRITE     _IOW(IOC_MAGIC, 1, ioctl_set_t)
#define IOCTL_READ      _IOR(IOC_MAGIC, 2, ioctl_set_t)
#define IOCTL_INFO      _IOR(IOC_MAGIC, 3, ioctl_set_t)
#define IOCTL_DDR_PARAM _IOR(IOC_MAGIC, 4, ioctl_set_t)
#define IOCTL_DDR_CTRL  _IOR(IOC_MAGIC, 5, ioctl_set_t)
#define IOCTL_RESET     _IOR(IOC_MAGIC, 6, ioctl_set_t)
#define IOCTL_STATUS    _IOR(IOC_MAGIC, 7, ioctl_set_t)
#define IOCTL_REG_WRITE _IOW(IOC_MAGIC, 8, ioctl_set_t)
#define IOCTL_REG_READ  _IOR(IOC_MAGIC, 9, ioctl_set_t)

#define DEVICE_NAME    "fmem"
#define DEVICE_FILE    "/dev/"DEVICE_NAME

//VPR-129
#define IOMAP_LENGTH  (128 * 1024)

// P1022DS
//#define IOMAP_LENGTH  (32 * 1024)

#endif // __FMDRIVER_H__
