/********************************************************
 *
 *  Copyright (c) 2015 Sony Corporation
 *
 ********************************************************/

#ifndef __SGDMA_DESC_H__
#define __SGDMA_DESC_H__

typedef struct {
    u32   read_addr;
    u32   write_addr;
    u32   length;
    u32   control;
} MsgdmaDescriptor_t;

#define MSGDMA_DESC_CTL_SET_CH(x)       ((x) & 0xff)
#define MSGDMA_DESC_CTL_GEN_SOP         BIT(8)
#define MSGDMA_DESC_CTL_GEN_EOP         BIT(9)
#define MSGDMA_DESC_CTL_PARK_READS      BIT(10)
#define MSGDMA_DESC_CTL_PARK_WRITES     BIT(11)
#define MSGDMA_DESC_CTL_END_ON_EOP      BIT(12)
#define MSGDMA_DESC_CTL_END_ON_LEN      BIT(13)
#define MSGDMA_DESC_CTL_TR_COMP_IRQ     BIT(14)
#define MSGDMA_DESC_CTL_EARLY_IRQ       BIT(15)
#define MSGDMA_DESC_CTL_TR_ERR_IRQ      (0xff << 16)
#define MSGDMA_DESC_CTL_EARLY_DONE      BIT(24)
#define MSGDMA_DESC_CTL_GO              BIT(31)

#endif /* __SGDMA_DESC_H__ */
